#!/usr/bin/python3

# Copyright (c) 2015, Rethink Robotics, Inc.

# Using this CvBridge Tutorial for converting
# ROS images to OpenCV2 images
# http://wiki.ros.org/cv_bridge/Tutorials/ConvertingBetweenROSImagesAndOpenCVImagesPython

# Using this OpenCV2 tutorial for saving Images:
# http://opencv-python-tutroals.readthedocs.org/en/latest/py_tutorials/py_gui/py_image_display/py_image_display.html

# rospy for the subscriber
import rospy
from dji_osdk_ros.srv import StereoVGASubscription
from dji_osdk_ros.srv import SetupCameraStream

def main():
    rospy.init_node('image_activation')

    # request drone to open stereo images
    rospy.wait_for_service('setup_camera_stream')
    try:
        camera_service_proxy = rospy.ServiceProxy('setup_camera_stream', SetupCameraStream)
        response = camera_service_proxy(rospy.get_param('camera_type'), 1)
        rospy.loginfo(response)
    except:
        rospy.loginfo("image service call failed")

if __name__ == '__main__':
    main()
