#!/usr/bin/python3
from tools import meters2lat_lon, lat_lon2meters, normalizeAngle
import numpy as np
import rospy

def generateWaypoints():
    rospy.init_node("waypointGenerator")
    anchorPoint = rospy.get_param("~anchorPoint")
    pathPoints = rospy.get_param("~pathPoints")
    baseWaypointAltitude = rospy.get_param("~altitude")
    droneNum = rospy.get_param("~droneNum")

    waypointAltitudeIncrement = baseWaypointAltitude # increase altitude for each drone in team

    # decide if path is "preplanned" or not
    if (len(pathPoints) != 0):
        apMeters = lat_lon2meters(anchorPoint)
        tempDict = {"waypoints" : {}, "positions" : {}, "numWaypoints" : 0, "numPositions" : 0}
        waypointDict = {}
        # define dictionary
        numWaypoints = len(pathPoints)
        numPositions = len(pathPoints)

        # print(waypointDict)

        for d in range(droneNum):
            # rospy.loginfo("blah!")
            # print(d)
            waypointDict["robot_{}".format(d)] = {}
            waypointDict["robot_{}".format(d)] = {}
            waypointDict["robot_{}".format(d)]["waypoints"] = {}
            waypointDict["robot_{}".format(d)]["positions"] = {}
            for i, pt in enumerate(pathPoints):
            # for i, offset in enumerate(waypointOffsets):
                waypointLatLon = pt
                waypointHeading = 0.0
                # waypointLatLon = meters2lat_lon([apMeters[0] + offset[0], apMeters[1] + offset[1]])
                # waypointLatLonRev = meters2lat_lon([apMeters[0] - offset[0], apMeters[1] - offset[1]])
                # waypointHeading = normalizeAngle(45*i)
                positionXY = lat_lon2meters(apMeters) - lat_lon2meters(pt)

                # waypoints
                waypointDict["robot_{}".format(d)]["waypoints"].update({"waypoint_{}".format(i) : [i, waypointLatLon[0], waypointLatLon[1], baseWaypointAltitude + d*5, waypointHeading]})
                # positions
                waypointDict["robot_{}".format(d)]["positions"].update({"position_{}".format(i) : [i, positionXY[0], positionXY[1], baseWaypointAltitude + d*5, waypointHeading]})

            # do this betta
            waypointDict["robot_{}".format(d)]["numWaypoints"] = numWaypoints
            waypointDict["robot_{}".format(d)]["numPositions"] = numPositions
        # print(waypointDict)
        rospy.set_param("/robot_list", waypointDict)
    else:
        # musical drones trajectory is convient test case, but general path is possible
        # ring sizes
        big = 2.0
        med = 2.0
        sml = 2.0

        apMeters = lat_lon2meters(anchorPoint)

        waypointOffsets = [
        [-big, -big],
        [big, -big],
        [big, big],
        [med, med],
        [-med, med],
        [-med, -med],
        [-sml, -sml],
        [sml, -sml],
        [sml, sml],
        [big, -big],
        ]
        tempDict = {"waypoints" : {}, "positions" : {}, "numWaypoints" : 0, "numPositions" : 0}
        waypointDict = {}
        # define dictionary
        # for temp in range(droneNum):
        #     waypointDict["robot_{}".format(temp)] = tempDict
        numWaypoints = len(waypointOffsets)
        numPositions = len(waypointOffsets) # TODO, add position list to parameters

        # print(waypointDict)

        for d in range(droneNum):
            # rospy.loginfo("blah!")
            # print(d)
            waypointDict["robot_{}".format(d)] = {}
            waypointDict["robot_{}".format(d)] = {}
            waypointDict["robot_{}".format(d)]["waypoints"] = {}
            waypointDict["robot_{}".format(d)]["positions"] = {}
            for i, offset in enumerate(waypointOffsets):
                waypointLatLon = meters2lat_lon([apMeters[0] + offset[0], apMeters[1] + offset[1]])
                waypointLatLonRev = meters2lat_lon([apMeters[0] - offset[0], apMeters[1] - offset[1]])
                waypointHeading = normalizeAngle(45*i)

                # waypoints
                waypointDict["robot_{}".format(d)]["waypoints"].update({"waypoint_{}".format(i) : [i, waypointLatLon[0], waypointLatLon[1], baseWaypointAltitude + d*waypointAltitudeIncrement, waypointHeading]})
                # positions
                waypointDict["robot_{}".format(d)]["positions"].update({"position_{}".format(i) : [i, offset[0], offset[1], baseWaypointAltitude + d*waypointAltitudeIncrement, waypointHeading]})

            # do this betta
            waypointDict["robot_{}".format(d)]["numWaypoints"] = numWaypoints
            waypointDict["robot_{}".format(d)]["numPositions"] = numPositions
        # print(waypointDict)
        rospy.set_param("/robot_list", waypointDict)
    return
    # print(waypointDict)

if __name__ == "__main__":
    generateWaypoints()
