#! /usr/bin/python3
import rospy
import sys
# from osc4py3.as_eventloop import *
# from osc4py3.as_allthreads import *
from osc4py3.as_comthreads import *
from osc4py3 import oscmethod as osm
from geometry_msgs.msg import Transform
from std_msgs.msg import Float32
import netifaces as ni

# blah blah blah
# AHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH

class OSCTranslator():
    def __init__(self):
        self.positionPub = rospy.Publisher('pd/target', Transform, queue_size = 1)

        self.paramMaxSpeedPub = rospy.Publisher('pd/parameters/maxSpeed', Float32, queue_size = 1)
        self.paramMaxYawSpeedPub = rospy.Publisher('pd/parameters/maxYawSpeed', Float32, queue_size = 1)
        self.paramSpeedScalePub = rospy.Publisher('pd/parameters/speedScale', Float32, queue_size = 1)
        self.paramUpdateRatePub = rospy.Publisher('pd/parameters/updateRate', Float32, queue_size = 1)
        self.paramDampingPub = rospy.Publisher('pd/parameters/damping', Float32, queue_size = 1)
        self.paramFrequencyPub = rospy.Publisher('pd/parameters/frequency', Float32, queue_size = 1)
        self.paramAngleOffsetPub = rospy.Publisher('pd/parameters/angleOffset', Float32, queue_size = 1)

        rospy.init_node('puredata_publisher')
        self.rate = rospy.Rate(100)
        self.target = Transform()
        rospy.loginfo("starting osc server")

        # Make server channels to receive packets.
        # get wifi interfaces ip

        # dont listen on the wireless when wanting it through the ethernet~
        # osc_udp_server(ni.ifaddresses('wlan0')[ni.AF_INET][0]['addr'], 3721, "aservername")
        osc_udp_server(ni.ifaddresses('eth0')[ni.AF_INET][0]['addr'], 3721, "aservername")
        osc_method("/position", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
        osc_method("/parameters", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
        osc_method("/sound/one", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
        osc_method("/master", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)

    def handlerfunctionflex(self, address, *args):
        # Will receive message data unpacked in s, x, y
        rospy.loginfo("from: " + address + ": " + str(args))
        if (address == "/position"):
            # rospy.loginfo("publishing position...")
            self.target.translation.x = args[0]
            self.target.translation.y = args[1]
            self.target.translation.z = args[2]
            self.target.rotation.x = args[3]
            self.positionPub.publish(self.target)

        elif (address == "/parameters/maxSpeed"):
            # rospy.loginfo("new maxSpeed param: " + str(args[0]))
            self.paramMaxSpeedPub.publish(args[0])
        elif (address == "/parameters/maxYawSpeed"):
            # rospy.loginfo("new maxYawSpeed param: " + str(args[0]))
            self.paramMaxYawSpeedSpeedPub.publish(args[0])
        elif (address == "/parameters/speedScale"):
            # rospy.loginfo("new speedScale param: " + str(args[0]))
            self.paramSpeedScalePub.publish(args[0])
        elif (address == "/parameters/updateRate"):
            # rospy.loginfo("new updateRate param: " + str(args[0]))
            self.paramUpdateRatePub.publish(args[0])
        elif (address == "/parameters/damping"):
            # rospy.loginfo("new damping param: " + str(args[0]))
            self.paramDampingPub.publish(args[0])
        elif (address == "/parameters/frequency"):
            # rospy.loginfo("new frequency param: " + str(args[0]))
            self.paramFrequencyPub.publish(args[0])
        elif (address == "/parameters/angleOffset"):
            # rospy.loginfo("new angleOffset param: " + str(args[0]))
            self.paramAngleOffsetPub.publish(args[0])


        elif (address == "/sound/one"):
            rospy.loginfo("publishing sound...")
        elif (address == "/master"):
            rospy.loginfo("publishing master vol...")
            # pure data will handle sounds..?
        pass

if __name__ == "__main__":
    osc_startup()
    oscer = OSCTranslator()
    rospy.loginfo("starting osc process loop")
    while not rospy.is_shutdown():
        # rospy.loginfo("processing osc msgs...")
        osc_process()
        oscer.rate.sleep()
    # rospy.spin()
    osc_terminate()
